package com.fr.plugin.api;

import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.decision.webservice.v10.login.TokenResource;
import com.fr.decision.webservice.v10.user.UserService;
import com.fr.plugin.context.PluginContexts;
import com.fr.third.socketio.SocketIOClient;
import com.fr.third.socketio.protocol.Packet;
import com.fr.third.socketio.protocol.PacketType;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.socketio.SocketIOServerFactory;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

public class ControlApi extends BaseHttpHandler {
    @Override
    public RequestMethod getMethod() {
        return null;
    }

    @Override
    public String getPath() {
        return "/control";
    }

    @Override
    public boolean isPublic() {
        return false;
    }

    @Override
    public void handle(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws Exception {
        Map<String, String> params = new HashMap<>();

        params.put("fine_auth_token", TokenResource.COOKIE.getToken(httpServletRequest));
        params.put("fine_user_name", UserService.getInstance().getCurrentUserIdFromCookie(httpServletRequest));
        if (PluginContexts.currentContext().isAvailable()) {
            // 做认证通过的事情
            WebUtils.writeOutTemplate("/com/fr/plugin/control.html",httpServletResponse,params);
        } else {
            // 做认证未通过的事情
            WebUtils.printAsString(httpServletResponse,"请联系开发获取授权");
        }
    }
 
}
