package com.fr.plugin.api;

import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.decision.webservice.Response;
import com.fr.decision.webservice.bean.entry.EntryBean;
import com.fr.decision.webservice.v10.entry.EntryService;
import com.fr.decision.webservice.v10.user.UserService;
import com.fr.plugin.utils.JSONUtils;
import com.fr.stable.StringUtils;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.socketio.SocketIOServerFactory;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class GetCatalogApi extends BaseHttpHandler {
    @Override
    public RequestMethod getMethod() {
        return null;
    }

    @Override
    public String getPath() {
        return "/entityList";
    }

    @Override
    public boolean isPublic() {
        return false;
    }

    @Override
    public void handle(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws Exception {
        String userId = UserService.getInstance().getCurrentUserIdFromCookie(httpServletRequest);
        List<EntryBean> allEntries = EntryService.getInstance().getAllEntries(userId);
        List<EntryBean> respEntries = new ArrayList<>();
        EntryBean root = null;
        for (EntryBean allEntry : allEntries) {
            //找到头部目录
            if (StringUtils.equals("decision-directory-root", allEntry.getpId()) && StringUtils.equals(allEntry.getText(), "大屏") && allEntry.getEntryType() == 3) {
                root = allEntry;
                break;
            }
        }
        if (root != null) {
            dgList(allEntries, respEntries, root);
        }
        EntryBean dhy=null;
        for (EntryBean respEntry : respEntries) {
            if (StringUtils.equals(respEntry.getText(),"导航页")) {
                dhy=respEntry;
                respEntries.remove(respEntry);
                break;
            }
        }

        Collections.sort(respEntries, (a, b) -> {
            if (a.getSortIndex() > b.getSortIndex()) {
                return 1;
            } else if (a.getSortIndex() == b.getSortIndex()) {
                return 0;
            } else {
                return -1;
            }
        });
        if (dhy != null) {
            respEntries.add(0,dhy);
        }
        WebUtils.printAsString(httpServletResponse, JSONUtils.serialize(Response.ok(respEntries)));
    }

    private void dgList(List<EntryBean> allEntries, List<EntryBean> respEntries, EntryBean root) {
        for (EntryBean allEntry : allEntries) {
            if (StringUtils.equals(root.getId(), allEntry.getpId())) {
                if (allEntry.getEntryType() == 3) {
                    dgList(allEntries, respEntries, allEntry);
                } else {
                    respEntries.add(allEntry);
                }
            }
        }
    }

}
